import { useEffect, useState } from 'react';
var useNetworkStatus = function () {
    var _a = useState(navigator.onLine), status = _a[0], setStatus = _a[1];
    var _b = useState(undefined), offlineAt = _b[0], setOfflineAt = _b[1];
    useEffect(function () {
        var handleOnline = function () {
            setStatus(true);
            setOfflineAt(undefined);
        };
        var handleOffline = function () {
            setStatus(false);
            setOfflineAt(new Date());
        };
        window.addEventListener('online', handleOnline);
        window.addEventListener('offline', handleOffline);
        return function () {
            window.removeEventListener('online', handleOnline);
            window.removeEventListener('offline', handleOffline);
        };
    }, []);
    return {
        isOnline: status,
        offlineAt: offlineAt,
    };
};
export default useNetworkStatus;
//# sourceMappingURL=../../src/dist/app/useNetworkStatus.js.map