import { useEffect, useRef } from 'react';
var useInterval = function (callback, delay) {
    var savedCallback = useRef(callback);
    // Remember the latest callback.
    useEffect(function () {
        savedCallback.current = callback;
    });
    // Set up the interval.
    useEffect(function () {
        function tick() {
            savedCallback.current();
        }
        if (delay !== null) {
            var id_1 = setInterval(tick, delay);
            return function () { return clearInterval(id_1); };
        }
    }, [delay]);
};
export default useInterval;
//# sourceMappingURL=../../src/dist/ux/useInterval.js.map