var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
var PAUSE = 'PAUSE';
var PLAY = 'PLAY';
var PROGRESS = 'PROGRESS';
var GO_BACKWARD = 'GO_BACKWARD';
var GO_FORWARD = 'GO_FORWARD';
var GO_TO = 'GO_TO';
var initialState = {
    currentIndex: 0,
    isPlaying: false,
    takeFocus: false
};
function useSlider(length, duration) {
    var reducer = function (state, action) {
        switch (action.type) {
            case GO_BACKWARD: return __assign({}, state, { currentIndex: (state.currentIndex - 1 + length) % length, isPlaying: false, takeFocus: false });
            case GO_FORWARD: return __assign({}, state, { currentIndex: (state.currentIndex + 1) % length, isPlaying: false, takeFocus: false });
            case GO_TO: return __assign({}, state, { currentIndex: action.index, isPlaying: false, takeFocus: true });
            case PAUSE: return __assign({}, state, { isPlaying: false, takeFocus: false });
            case PLAY: return __assign({}, state, { isPlaying: true, takeFocus: false });
            case PROGRESS: return __assign({}, state, { currentIndex: (state.currentIndex + 1) % length, isPlaying: true, takeFocus: false });
            default: return state;
        }
    };
    var _a = React.useReducer(reducer, initialState), state = _a[0], dispatch = _a[1];
    var goBackward = function () { return dispatch({ type: GO_BACKWARD }); };
    var goForward = function () { return dispatch({ type: GO_FORWARD }); };
    var goTo = function (index) { return dispatch({ index: index, type: GO_TO }); };
    var pause = function () { return dispatch({ type: PAUSE }); };
    var play = function () { return dispatch({ type: PLAY }); };
    var progress = function () { return dispatch({ type: PROGRESS }); };
    React.useEffect(function () {
        if (state.isPlaying) {
            var timeout_1 = setTimeout(progress, duration);
            return function () { return clearTimeout(timeout_1); };
        }
    }, [state.currentIndex, state.isPlaying]);
    return {
        goBackward: goBackward,
        goForward: goForward,
        goTo: goTo,
        pause: pause,
        play: play,
        state: state
    };
}
export default useSlider;
//# sourceMappingURL=../../src/dist/ux/useSlider.jsx.map