import { useEffect, useState } from 'react';
import throttle from './throttle';
export var useWindowScrollPosition = function (_a) {
    var _b = (_a === void 0 ? {} : _a).throttleMs, throttleMs = _b === void 0 ? 100 : _b;
    var _c = useState({
        x: window.pageXOffset,
        y: window.pageYOffset,
    }), scroll = _c[0], setScroll = _c[1];
    var handle = throttle(function () {
        setScroll({
            x: window.pageXOffset,
            y: window.pageYOffset,
        });
    }, throttleMs);
    useEffect(function () {
        window.addEventListener('scroll', handle);
        return function () {
            window.removeEventListener('scroll', handle);
        };
    }, []);
    return scroll;
};
//# sourceMappingURL=../../src/dist/ux/useWindowScrollPosition.js.map